package jobs

import (
	"context"
	"fmt"
	"time"

	"quyun/app/models"
	"quyun/database/fields"

	"github.com/go-pay/gopay/wechat/v3"
	"github.com/pkg/errors"
	. "github.com/riverqueue/river"
	log "github.com/sirupsen/logrus"
	_ "go.ipao.vip/atom"
	"go.ipao.vip/atom/contracts"
	_ "go.ipao.vip/atom/contracts"
)

var _ contracts.JobArgs = (*WechatPayNotify)(nil)

type WechatPayNotify struct {
	Notify *wechat.V3DecryptPayResult `json:"notify"`
}

func (s WechatPayNotify) InsertOpts() InsertOpts {
	return InsertOpts{
		Queue:    QueueDefault,
		Priority: PriorityDefault,
	}
}

func (WechatPayNotify) Kind() string       { return "wechat_pay_notify" }
func (a WechatPayNotify) UniqueID() string { return a.Kind() }

var _ Worker[WechatPayNotify] = (*WechatPayNotifyWorker)(nil)

// @provider(job)
type WechatPayNotifyWorker struct {
	WorkerDefaults[WechatPayNotify]
}

func (w *WechatPayNotifyWorker) Work(ctx context.Context, job *Job[WechatPayNotify]) error {
	log := log.WithField("job", job.Args.Kind())

	log.Infof("[Start] Working on job with strings: %+v", job.Args)
	defer log.Infof("[End] Finished %s", job.Args.Kind())

	notify := job.Args.Notify

	if notify.TradeState != "SUCCESS" {
		log.Warnf("TradeState is not SUCCESS for order %s", notify.OutTradeNo)
		return JobCancel(errors.New("TradeState is not SUCCESS"))
	}

	order, err := models.Orders.GetByOrderNo(context.Background(), notify.OutTradeNo)
	if err != nil {
		log.Errorf("GetByOrderNo error:%v", err)
		return err
	}

	if order.Status != fields.OrderStatusPending {
		log.Infof("Order %s is paid, processing...", job.Args.Notify.OutTradeNo)
		return JobCancel(fmt.Errorf("Order already paid, currently status: %d", order.Status))
	}

	user, err := models.Users.GetByID(context.Background(), order.UserID)
	if err != nil {
		return errors.Wrapf(err, "get user by id(%d) failed", order.UserID)
	}
	meta := order.Meta.Data

	needToPay := order.Price*int64(order.Discount)/100 - meta.CostBalance
	if int64(notify.Amount.Total) != needToPay {
		log.Errorf("Order %s amount mismatch: expected %d, got %d", job.Args.Notify.OutTradeNo, needToPay, notify.Amount.Total)
		return fmt.Errorf("amount mismatch for order %s", job.Args.Notify.OutTradeNo)
	}

	order.TransactionID = notify.TransactionId
	order.Currency = notify.Amount.Currency
	order.PaymentMethod = notify.TradeType
	order.Status = fields.OrderStatusCompleted

	meta.PayNotify = notify
	order.Meta = fields.ToJson(meta)

	log.Infof("Updated order details: %+v", order)
	tx, err := models.Transaction(ctx)
	if err != nil {
		return errors.Wrap(err, "Transaction error")
	}
	defer tx.Rollback()

	// update user balance
	err = models.Users.SetBalance(ctx, user.ID, user.Balance-meta.CostBalance)
	if err != nil {
		log.WithError(err).Error("SetBalance error")
		return JobCancel(errors.Wrap(err, "set user balance failed"))
	}

	if err := models.Users.BuyPosts(context.Background(), order.UserID, order.PostID, order.Price); err != nil {
		log.Errorf("BuyPosts error:%v", err)
		return errors.Wrap(err, "BuyPosts error")
	}

	if err := models.Orders.Update(context.Background(), order); err != nil {
		log.Errorf("Update order error:%v", err)
		return errors.Wrap(err, "Update order error")
	}
	if err := tx.Commit(); err != nil {
		log.Errorf("Commit error:%v", err)
		return errors.Wrap(err, "Commit error")
	}

	log.Infof("Successfully processed order %s", notify.OutTradeNo)
	return nil
}

func (w *WechatPayNotifyWorker) NextRetry(job *Job[WechatPayNotify]) time.Time {
	return time.Now().Add(30 * time.Second)
}
